from __future__ import annotations

from src.infrastructure.decorators.value_objects import valueobject
from src.infrastructure.models.base_model import BaseModel
from src.infrastructure.models.field import Field


@valueobject
class Usage(BaseModel):
    prompt_tokens: int = Field(description="Number of tokens consumed by the prompt")
    completion_tokens: int = Field(
        description="Number of tokens consumed by the completion."
    )

    def __add__(self, other: Usage) -> Usage:
        return Usage(
            prompt_tokens=self.prompt_tokens + other.prompt_tokens,
            completion_tokens=self.completion_tokens + other.completion_tokens,
        )
